/* $Id: elm.h,v 1.12 2000/11/04 08:05:21 hurtta Exp $ */

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.12 $   $State: Exp $
 *
 *  Modified by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  The Elm Mail System 
 *
 * 			Copyright (c) 1988-1992 USENET Community Trust
 * 			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

/**  Main header file for ELM mail system.  **/


#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include <signal.h>

#include "defs.h"
#include <setjmp.h>
/*
#include "melib.h"
*/

#include "elmlib.h"
#include "elm_curses.h"

/******** static character string containing the version number  *******/

static char ident[] = { WHAT_STRING };

/******** and another string for the copyright notice            ********/

static char copyright[] = { 
		"@(#)          (C) Copyright 1986,1987, Dave Taylor\n\
@(#)          (C) Copyright 1988-1992, The Usenet Community Trust\n\
@(#)          (C) Copyright 1996-2000, Kari Hurtta\n" };

/******** global variables accessable by all pieces of the program *******/


int check_size = 0;		/* don't start mailer if no mail */
int current = 0;		/* current message number  */
int header_page = 0;     	/* current header page     */
int inalias = 0;		/* TRUE if in the alias menu */
int last_current = -1;		/* previous current message */
int last_header_page = -1;     	/* last header page        */
int message_count = 0;		/* max message number      */
int headers_per_page = 0;	/* number of headers/page  */
int original_umask = 0;		/* original umask, for restore before subshell */
int sendmail_verbose = 0;       /* Extended mail debugging */
int redraw = 0,	 		/* do we need to rewrite the entire screen? */
    nucurr = 0,	 		/* change list or just the current pointer...   */
    nufoot = 0;	 		/* clear lines 16 thru bottom and new menu  */

struct folder_info * current_folder = NULL;
char cur_editfile[SLEN] = {0};  /* editor buffer */





char item[WLEN] = "message";	/* either "message" or "alias" */
char items[WLEN] = "messages";	/* plural: either "messages" or "aliases" */
char Item[WLEN] = "Message";	/* CAP: either "Message" or "Alias" */
char Items[WLEN] = "Messages";	/* CAP-plural: either "Messages" or "Aliases" */
char Prompt[WLEN] = "Command: ";	/* Menu Prompt: either "Command" or "Alias" */

char batch_subject[SLEN] = {0};	/* subject buffer for batchmail */
char included_file[SLEN] = {0};	/* prepared file to include in the edit buf */
mime_t *attach_files = NULL;    /* prepare attachments for sending */

char version_buff[NLEN] = {0};	/* version buffer */
 
char *def_ans_yes;		/* default yes answer - single char, lc	*/
char *def_ans_no;		/* default no answer - single char, lc	*/
char *nls_deleted;		/* [deleted] */
char *nls_form;			/* Form */
char *nls_message;		/* Message */
char *nls_to;			/* To */
char *nls_from;			/* From */
char *nls_page;			/* Page */
char *change_word;		/* change */
char *save_word;		/* save */
char *copy_word;		/* copy */
char *cap_save_word;		/* Save */
char *cap_copy_word;		/* Copy */
char *saved_word;		/* saved */
char *copied_word;		/* copied */

char backspace,			/* the current backspace char */

     kill_line,			/* the current kill-line char */
     word_erase,		/* the current word-erase char */
     interrupt_char,		/* the current interrupt char */
     reprint_char,		/* the current reprint-line char */
     eof_char;			/* the current end-of-file char */

int  has_highlighting = FALSE;	/* highlighting available? */






int write_elmrc = 0;            /* flag: write elmrc in starting    */













int mail_only = 0;		/* flag: send mail then leave?      */
int check_only = 0;		/* flag: check aliases then leave?  */
int batch_only = 0;		/* flag: send without prompting?    */









int selected = 0;		/* flag: used for select stuff      */




















/** set up some default values for a 'typical' terminal *snicker* **/

int elm_LINES=23;		/** lines per screen      **/
int elm_COLUMNS=80;		/** columns per page      **/
#ifdef SIGWINCH
VOLATILE int resize_screen = 0;		/** SIGWINCH occured?	  **/
#endif
VOLATILE int redraw_screen = 0;          /* Elm suspended?          */
#ifdef BACKGROUD_PROCESSES       
VOLATILE int handle_sigchld = 0;       /* got SIGCHLD */

#endif


long size_of_pathfd;		/** size of pathfile, 0 if none **/

FILE *pathfd;			/* path alias file          */
FILE *domainfd;			/* domain file		    */



int   max_headers = 0;		/* number of headers alloated */

struct header_rec **headers;    /* array of header structure pointers */

struct alias_rec **aliases;     /* for the alias menu */
int   max_aliases = 0;		/* number of aliases allocated */



int system_data = -1;		/* fileno of system data file */
int user_data = -1;		/* fileno of user data file   */







JMP_BUF GetPromptBuf;		/* setjmp buffer */
int InGetPrompt;		/* set if in GetPrompt() in read() */
#ifdef USE_PGP

int pgp_status=0;    /* var to keep track of pgp internals */




#endif
int me_retcode;

short mime_count = 0; /* A counter used so that each call to
                       * mime_generate_boundary() returns a unique value.
                       */

#ifdef USE_REMAILER
int remailing;
#endif
