static char rcsid[] = "@(#)$Id: getaddrfrm.c,v 1.6 2001/06/06 18:08:59 hurtta Exp $";

/******************************************************************************
 *  The Elm (ME+) Mail System  -  $Revision: 1.6 $   $State: Exp $
 *
 *  Reimplemented by: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
 ******************************************************************************
 *  This code is reimplemented. Original code was following copyright:
 *
 *  The Elm Mail System 
 *
 *			Copyright (c) 1988-1992 USENET Community Trust
 *			Copyright (c) 1986,1987 Dave Taylor
 *****************************************************************************/

#include "headers.h"

DEBUG_VAR(Debug,__FILE__,"addr");

void get_address_from(line, buffer, size)
     char *line, *buffer;
     int size;
{
	/** This routine extracts the address from a 'From:' line
	**/

  struct addr_item * list;

  DPRINT(Debug,11,(&Debug, 
		   "get_address_from: line=%.100s, size=%d\n",
		   line,size));

  no_ret(line);		/* blow away '\n' char! */

  list = break_down_address(line,0,display_charset);

  buffer[0]='\0';

  if (list) {
    struct addr_item * ptr;

    for (ptr=list; ptr->addr; ptr++) {
      char *t = ptr->addr;
      if (ptr == list)
	strfcpy(buffer, t, size);
      else {
	strfcat(buffer, ", ", size);
	strfcat(buffer, t, size);
      }
    }

  } 

  free_addr_items(list);

  DPRINT(Debug,11,(&Debug, 
		   "get_address_from: buffer=%.100s\n",
		   buffer));
}



