case $CONFIG in
'')
    if test ! -f config.sh; then
	ln ../config.sh . || \
	ln ../../config.sh . || \
	ln ../../../config.sh . || \
	(echo "Can't find config.sh."; exit 1)
    fi
    . ./config.sh
    ;;
esac
case "$0" in
*/*) cd `expr X$0 : 'X\(.*\)/'` ;;
esac


echo "Extracting shared_libs/iconv/Makefile (with variable substitutions)"
$cat >Makefile <<!GROK!THIS!
# $Id: Makefile.SH,v 1.1.2.3 2001/07/07 20:07:12 hurtta Exp $
#
#
#  Makefile for the ELM (ME+) mail program.
#
#  Author: Kari Hurtta <hurtta+elm@ozone.FMI.FI>
#
#
INSTLIB		= $shlib/libelmme-iconv.so$d_shared_rev
AR		=	ar
CC		=	$cc
CCFLAGS		=	$ccflags $xencf
CP		=	$cp
RM              =       $rm -f
MV              =       $mv
OPTIMIZE	=	$optimize
RANLIB		=	$ranlib
TOUCH           =       $touch
CHMOD           =       $chmod
SONAME          = ${soname_opt}$shlib/libelmme-iconv.so$d_shared_rev
!GROK!THIS!

if $test "$iconv_lib_dir" != ""; then
    $cat >>Makefile <<EOS
LIBDIRLIST      =  -L$iconv_lib_dir $rpath_opt$iconv_lib_dir
EOS
else
    cat >>Makefile <<'EOX'
LIBDIRLIST      =
EOX
fi

if $test "$iconv_include_dir" != "" ; then
    $cat >>Makefile <<EOS
INCDIRLIST      = -I$iconv_include_dir
EOS
else
    $cat >>Makefile <<'EOX'
INCDIRLIST      =
EOX
fi

if $test "$iconv_link" != "" ; then
    $cat >>Makefile <<EOS
ICONV_LINK	= 	-l$iconv_link
EOS
else
    $cat >>Makefile <<'EOX'
ICONV_LINK	=
EOX
fi

$cat >>Makefile <<'!NO!SUBS!'
CFLAGS		=	-I$(INCLDIR) $(INCDIRLIST) $(CCFLAGS) $(OPTIMIZE)
INCLDIR		=	../include
OBJS            =       iconv.o

all:	Makefile libiconv.a ../../shlib/libelmme-iconv.so
install: all $(INSTLIB)
uninstall:
clean: 
	rm -f $(OBJS) ../../shlib/libelmme-iconv.so libiconv.a

.PRECIOUS: $(INCLDIR)/elmshared.h ../../hdrs/defs.h 

$(INCLDIR)/elmshared.h: ../../hdrs/defs.h ../../hdrs/patchlevel.h ../../hdrs/elmlib.h $(INCLDIR)/shared.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

../../hdrs/defs.h: ../../config.h ../../hdrs/sysdefs.h
		$(CHMOD) u+w $@
		$(TOUCH) $@

Makefile: Makefile.SH ../../config.sh config.res
	@echo "You must run 'sh Configure -S' or 'sh Configure'"
	exit 1

../../config.sh config.res:
	@echo "You must run 'sh Configure'"
	exit 1

lint:		

tags:

clean:		

elmiconv.h: $(INCLDIR)/elmshared.h  ../../hdrs/cs_imp.h
	$(CHMOD) u+w $@
	$(TOUCH) $@

iconv.o: elmiconv.h ../../hdrs/rc_imp.h ../../hdrs/save_opts.h

libiconv.a: $(OBJS)
	$(AR) r $@ $?
	$(RANLIB) $@

../../shlib/libelmme-iconv.so: $(OBJS)
	$(CC) $(CCFLAGS) $(LIBDIRLIST) $(SONAME) -o $@ $(OBJS) $(ICONV_LINK)

$(INSTLIB): ../../shlib/libelmme-iconv.so
	-$(MV) $@ $@.old
	-$(RM) $@.old
	$(CP) ../../shlib/libelmme-iconv.so $@
	$(CHMOD) ugo=r $@

!NO!SUBS!
